((xmlDocReader) => {
   isFirefox = typeof InstallTrigger !== 'undefined';
   const ua = !isFirefox ? chrome : browser;

   function updateicon(state) {
      if (state) {
         ua.storage.local.get('_userinfo', function(data) {
            if (data._userinfo && data._userinfo.autorun) {
               ua.browserAction.setIcon({ path : {"16": "data/edit-16.png", "24": "data/edit-24.png", "32": "data/edit-32.png", "64": "data/edit-64.png" }});
            } else {
               ua.browserAction.setIcon({ path : {"16": "data/edit-16s.png", "24": "data/edit-24s.png", "32": "data/edit-32s.png", "64": "data/edit-64s.png" }}); }
         });
      } else {
         ua.browserAction.setIcon({ path : {"16": "data/edit-16b.png", "24": "data/edit-24b.png", "32": "data/edit-32b.png", "64": "data/edit-64b.png" }});
      }
   }

   function notify (request, sender, sendResponse)
   { if (request.message === "XMLparsing") {
          ua.notifications.create({
             "type": "basic",
             "iconUrl": (request.data.utype == 0 ? ua.runtime.getURL("icons/user-48.png"): ua.runtime.getURL("icons/comp-48.png")),
             "title": (request.data.utype == 0 ? (request.data.uowner == false?'Фiзична особа (спадкоємець)':'Фiзична особа'):'Юридична особа'),
             "message": request.data.uname + '\r\n' + (request.data.uinn!=null?request.data.uinn:'') + '\r\n' + (request.data.uaddr!=null?request.data.uaddr:'')
          });
          sendResponse({response: "Response message from background script"}); 
     } else if (request.message === "XMLnotify") {
          setTimeout (function () {
             ua.notifications.create({
                "type": "basic",
                "iconUrl": request.data.alert?ua.runtime.getURL("icons/alert-48.png"):ua.runtime.getURL("icons/error-48.png"),
                "title": request.data.alert?'Повiдомлення!':'Помилка!',
                "message": request.data.alert?request.data.alert:request.data.error
             }); 
          }, 1000);
     } else if (request.message === "PDFfile") {
          ua.notifications.create({
             "type": "basic",
             "iconUrl": (request.data.size > 15000000 ? ua.runtime.getURL("icons/alert-48.png") : ua.runtime.getURL("icons/PDF-icon-48.png")),
             "title": (request.data.size > 15000000 ? 'Розмiр файлу перевищує 15Mb (' + (request.data.size / 1000000).toFixed(2) + 'Mb)':'Файл PDF'),
             "message": ('Кiлькiсть сторiнок документу: ' + request.data.pages + '\r\n' + 'Розмiр файлу: ' + (request.data.size / 1000000).toFixed(2) + 'Mb')
          });
     } else if (request.message === "XMLtitle") {
       if (request.data.error) {
           ua.browserAction.setTitle({title: request.data.error});
           ua.browserAction.setBadgeText({text: 'ERR'});
           ua.browserAction.setBadgeBackgroundColor({color:"#f00"});
       } else {
           var title = "XMLDocReader"
           ua.browserAction.setTitle({title: title});
           ua.browserAction.setBadgeText({text: request.data.btext});
           ua.browserAction.setBadgeBackgroundColor({color:"#0000FF"});
       }
     } else if (request.message === "XMLiupdate") {       // оновлення з меню налаштувань
        updateicon(true);
        updateActiveTab();
     } else if (request.message === "XMLRequest") {
        const networkFilters = { urls: [ request.url ] };
//        ua.webRequest.onBeforeRequest.addListener( function (c) {
//        }, networkFilters );
           ua.webRequest.onCompleted.addListener( function (c) {
              sendResponse({ '_xhrRequest': 'success' });
           }, networkFilters );
           ua.webRequest.onErrorOccurred.addListener( (e) => {
              sendResponse({ '_xhrRequest': 'error' });
           }, networkFilters);
        // https://stackoverflow.com/questions/30018302/chrome-webrequest-oncompleted-vs-chrome-runtime-onmessage-race
        // returning `true` to indicate that we intend to send later, cf. <https://developer.chrome.com/extensions/runtime#event-onMessage>
        return true;
     }
   }

   function updateActiveTab(tabs) {
      var updateTab = function(tabs) {
         if (tabs.length > 0) {
            var pos = tabs[0].url.indexOf('https://e.land.gov.ua/', 0);
            if (pos === 0) { updateicon(true);   ua.browserAction.enable(); ua.tabs.sendMessage(tabs[0].id, {method: "XMLUpdatePopup", url : tabs[0].url } ); }
            else           { updateicon(false); ua.browserAction.disable(); notify({message: "XMLtitle", data: {"btext": ''} }); }
         }
      }
      ua.tabs.query({active: true, currentWindow: true}, updateTab);
   }

   function updatePopup (tabs, changeInfo, tabInfo) {
      if (changeInfo.url) {
         var pos = changeInfo.url.indexOf('https://e.land.gov.ua/', 0);
         if (pos === 0) {  updateicon(true);  ua.browserAction.enable(); }
         else           { updateicon(false); ua.browserAction.disable(); }
         
      }
   }

   ua.webRequest.onBeforeSendHeaders.addListener(function(details) {
       for(var n in details.requestHeaders){
           if(details.requestHeaders[n].name.toLowerCase()==".referer"){
               details.requestHeaders[n].name = "Referer";
               break;
           } else if (details.requestHeaders[n].name.toLowerCase()==".user-agent"){
               details.requestHeaders[n].name = "User-Agent";
               break;
           } else if (details.requestHeaders[n].name.toLowerCase()==".content-length"){
               details.requestHeaders[n].name = "Content-length";
               break;
           } else if (details.requestHeaders[n].name.toLowerCase()==".connection"){
               details.requestHeaders[n].name = "Connection";
               break;
           }
       }
       return {requestHeaders:details.requestHeaders};
   },{
       urls:["http://*/*", "https://*/*"]
   },[
       "requestHeaders",
       "blocking"
   ]);

   ua.tabs.onUpdated.addListener(updatePopup);
   ua.tabs.onActivated.addListener(updateActiveTab);
   ua.runtime.onMessage.addListener(notify);
   updateActiveTab();
})();
