(function(XRecaptcha) {
   window.addEventListener('message', function receiveMessage(event) {
     if (event.origin !== 'https://e.land.gov.ua' || event.source !== window) return;

     if(event.data.action === 'XDR_RECAPTCHA_GET') {
        grecaptcha.ready(function() {
           grecaptcha.execute(recaptcha3_publicKey, {
             action: "parcel_registration_modify"
           }).then(function(token) {
              window.dispatchEvent(new CustomEvent('XDR_RECAPTCHA_TOKEN', { 'detail': { 'token' : token } } ));
           });
        });
     } else if(event.data.action === 'XDR_FILE_SIGN') {
        var file = event.data.file;
        if (file) {
          EU_MAX_DATA_SIZE_MB = Math.ceil(file.size / 1024 / 1024);
          var reader = new FileReader();
          reader.onerror = function(event) {
             window.dispatchEvent(new CustomEvent('XDR_SIGNED_FILE', { 'detail': { 'error' : event.target.error.code } } ));
          }, reader.onload = function() {
            var euSignFull = new EuSignFull("sign");
            euSignFull.load(function() {
              // якщо файл перевірено і підписано
              euSignFull.verifyDataInternal(new Uint8Array(reader.result), function(data) {
                console.log('* Файл успішно перевірено та прочитано');
                window.dispatchEvent(new CustomEvent('XDR_SIGNED_FILE', { 'detail': { 'file' : file } } ) );
                //xmlSigned._data = reader.result, xmlSigned._filename = file.name;
              }, function(result) {
                 // інакше перепідписуємо
                 console.log('* Файл успішно прочитано (накладаємо підпис)');

                 function _ReadPrivateKeyBinary(file, pass, certs, onSuccess, onError) {
                    if (!file) { onError('Помилка читання даних з файлу. Файл порожній.'); return; }
                    var i, d, l, array;
                    d = file;
                    l = d.length;
                    array = new Uint8Array(l);
                    for (var i = 0; i < l; i++){
                        array[i] = d.charCodeAt(i);
                    }

                    var cFile = new File( [array], 'storage_key_file.dat', { type: "application/octet-stream", lastModified: Date.now(), lastModifiedDate: Date.now() } );
                    var pThis = euSignFull, keyFile = cFile, password = pass, certsFiles = certs, files = [];
                    if (files.push(keyFile), pThis.m_selectUserCerts) for (var i = 0; i < certsFiles.length; i++) files.push(certsFiles[i]);
             
                    eu_wait(function(runNext) {
                        pThis.m_iface.ReadFiles(files, runNext, onError );
                    }).eu_wait(function(runNext, readedFiles) {
                        var certs = null;
                        if (pThis.m_selectUserCerts) {
                            certs = [];
                            for (var i = 1; i < readedFiles.length; i++) certs.push(readedFiles[i].data);
                        }
                        pThis.m_iface.ReadPrivateKeyBinary(readedFiles[0].data, password, certs, runNext, onError );
                    }).eu_wait(function(runNext, key) {
                        key.name = keyFile.name, onSuccess(key);
                    });
                 }
                 _ReadPrivateKeyBinary(event.data.cFile, event.data.cPassword, event.data.cCerts, 
                    function onSuccess(key) { 
                       var pThis = euSignFull;
                       if (null != key.signCert) pThis.m_userKey = key, null != edrdSignSessionStorage && edrdSignSessionStorage.setItem(edrdSignSessionStorage.USER_KEY_ID, pThis._keyToStorageKey(pThis.m_userKey)), 
                          null != edrdSignLocalStorage && edrdSignLocalStorage.setItem(edrdSignLocalStorage.USER_CA_ID, pThis.m_CAServer); 
                       euSignFull.m_iface.SignDataInternal(!0, new Uint8Array(reader.result), !1, 
                          function onSuccess(sign) {
                             window.dispatchEvent(new CustomEvent('XDR_SIGNED_FILE', { 'detail': { 'file' : new File([sign.buffer], 'default.p7s', {type: "application/pkcs7-signed-data" } ) } } ) );
                          }, function onError(e) { 
                             window.dispatchEvent(new CustomEvent('XDR_SIGNED_FILE', { 'detail': { 'error' : e } } ));
                          });
                    }, function onError(e) { 
                       window.dispatchEvent(new CustomEvent('XDR_SIGNED_FILE', { 'detail': { 'error' : 'Виникла помилка при зчитуванні особистого ключа' } } ));
                       console.log('ReadPrivateKeyBinary error: ', e); 
                    }); 
              });
            }, function(error) {
               console.log(error);
            });
          }, reader.readAsArrayBuffer(file);
        }
     }
   }, false);
})();