class XMLClass {
   constructor () {
      this.coordsys = [];
      this.cadastreNumber = '';
   }

   norm(el) { if (el.normalize) { el.normalize(); } return el; }
   get(x, y)  { try {return x.getElementsByTagName(y);} catch(e) {return null;} };
   get1(x, y) { try {var n = this.get(x, y); return n.length ? n[0] : null; } catch(e) {return null;} };
   nodeVal(x) {
      if (x) { this.norm(x); }
      return (x && x.firstChild && x.firstChild.nodeValue) || '';
   }

   addVal( s, t, n)  {
      if (this.get1( t, n)) { 
          var str = this.nodeVal( this.get1( t, n));
          if (str.length > 0) {
              if (s.length > 0) s += ", ";
              s += str;
          }
      };
      return s;
   }

   getXmlStr(xml) {
      if (window.ActiveXObject) { return xml.xml; }
      var str = new XMLSerializer().serializeToString(xml);
      str = str.split(" ").join("");
      return '<xmp>' +str +'</xmp>';
   }

   xmlCoords(lines, lands, points) {
      var size = 500000, coords = [];
      var line = this.get( lines, 'Line');
      
      for (var l = 0; l < line.length; l++) 
      {   var ln = line[ l];
          var ulid = this.get1( ln, 'ULID').textContent,
              fp   = this.get1( ln, 'FP') ? this.get1( ln, 'FP').textContent : 0,
              tp   = this.get1( ln, 'TP') ? this.get1( ln, 'TP').textContent : 0,
              land = lands[ ulid];
      
          if (fp != tp && fp == land[ land.length -1]) {
              for (var j = land.length -1; j >= 0; j--) {
                  if (coords.length == 0 || (coords[coords.length - 1][0] != points[ land[j]].x || coords[coords.length - 1][1] != points[ land[j]].y)) { 
                     coords.push( [points[ land[j]].x, points[ land[j]].y]);
                     //console.log('fp != tp: ' + j + ' x=' + points[ land[j]].x + ' y=' + points[ land[j]].y);
                  }
              }
          } else {
              for (var j = 0; j < land.length; j++) {
                  if (coords.length == 0 || (coords[coords.length - 1][0] != points[ land[j]].x || coords[coords.length - 1][1] != points[ land[j]].y)) { 
                     coords.push( [points[ land[j]].x, points[ land[j]].y]);
                     //console.log('fp == tp: ' + j + ' x=' + points[ land[j]].x + ' y=' + points[ land[j]].y);
                  }
              }
          }
      }
         var id=0, name='';
         switch(this.coordsys.name.toUpperCase()) {
            case    'SC42': id=   '-42'; name='СК-42 (x, y) стандартні 6° зони'; break;
            case    'SC63': id=   '-63'; name='СК-63 (x, y) район Х стандартні зони'; break;
            case 'USC2000': id= '-2000'; name='УСК-2000 (x, y) стандартні 6° зони'; break;
            case  'МСК-01': id='700001'; name='(АР Крим)'; break;
            case  'МСК-05': id='700002'; name='(Вінницька область)'; break;
            case  'МСК-07': id='700003'; name='(Волинська область)'; break;
            case  'МСК-12': id='700004'; name='(Дніпропетровська область)'; break;
            case  'МСК-14': id='700005'; name='(Донецька область)'; break;
            case  'МСК-18': id='700006'; name='(Житомирська область)'; break;
            case  'МСК-21': id='700007'; name='(Закарпатська область)'; break;
            case  'МСК-23': id='700008'; name='(Запорізька область)'; break;
            case  'МСК-26': id='700009'; name='(Івано-Франківська область)'; break;
            case  'МСК-35': id='700010'; name='(Кіровоградська область)'; break;
            case  'МСК-32': id='700011'; name='(Київська область)'; break;
            case  'МСК-44': id='700013'; name='(Луганська область)'; break;
            case  'МСК-46': id='700014'; name='(Львівська область)'; break;
            case  'МСК-48': id='700015'; name='(Миколаївська область)'; break;
            case  'МСК-51': id='700016'; name='(Одеська область)'; break;
            case  'МСК-53': id='700017'; name='(Полтавська область)'; break;
            case  'МСК-56': id='700018'; name='(Рівненська область)'; break;
            case  'МСК-59': id='700019'; name='(Сумська область)'; break;
            case  'МСК-61': id='700020'; name='(Тернопільська область)'; break;
            case  'МСК-63': id='700021'; name='(Харківська область)'; break;
            case  'МСК-65': id='700022'; name='(Херсонська область)'; break;
            case  'МСК-68': id='700023'; name='(Хмельницька область)'; break;
            case  'МСК-71': id='700024'; name='(Черкаська область)'; break;
            case  'МСК-73': id='700025'; name='(Чернівецька область)'; break;
            case  'МСК-74': id='700026'; name='(Чернігівська область)'; break;
            case  'МСК-80': id='700012'; name='(м. Київ)'; break;
            case  'МСК-84': id='700027'; name='(м. Севастополь)'; break;
            default:        id='0'; name='Мiсцева система координат';
         }
         this.coordsys.id = id, this.coordsys.desc = name;
         console.log('Система координат: ' + this.coordsys.name + '(' + this.coordsys.desc + ') id: ' + this.coordsys.id);

         return coords;
   };

   async checkInObject(coords) {
      function getSK63ZoneProj4(x) {
         var size = 500000, lon0 = 0, x0 = 0;
         if (x >= 1300000 -size && x < 1300000 +size) {lon0 = '23.5'; x0 = 1300000;}
         if (x >= 2300000 -size && x < 2300000 +size) {lon0 = '26.5'; x0 = 2300000;}
         if (x >= 3300000 -size && x < 3300000 +size) {lon0 = '29.5'; x0 = 3300000;}
         if (x >= 4300000 -size && x < 4300000 +size) {lon0 = '32.5'; x0 = 4300000;}
         if (x >= 5300000 -size && x < 5300000 +size) {lon0 = '35.5'; x0 = 5300000;}
         if (x >= 6300000 -size && x < 6300000 +size) {lon0 = '38.5'; x0 = 6300000;}
         if (x >= 7300000 -size && x < 7300000 +size) {lon0 = '41.5'; x0 = 7300000;}
         if (x0 > 0) return "+proj=tmerc +ellps=krass +lon_0=" + lon0 +" +lat_0=0 +k=1 +x_0=" + x0 +" +y_0=-9214.69 +towgs84=25,-141,-78.5,0,0.35,0.736,0 +units=m +no_defs";
         else return null;
      }

      var minx, miny, maxx, maxy, crc, dst;
      for (var i=0;i<coords.length;i++){
         crc = getSK63ZoneProj4(coords[i][1]);
         if (!crc) return {'error':'Система координат є відмінною від СК-63\r\nПошук інформації про перетин здійснюється виключно за координатами в СК-63' };
         dst = "+proj=longlat +ellps=WGS84 +datum=WGS84 +no_defs";
         var ll = proj4(crc, dst, [ coords[i][1], coords[i][0] ]);
         crc = "+proj=longlat +ellps=WGS84 +datum=WGS84 +no_defs";
         dst = "+proj=merc +a=6378137 +b=6378137 +lat_ts=0.0 +lon_0=0.0 +x_0=0.0 +y_0=0 +k=1.0 +units=m +no_defs";
         ll = proj4(crc, dst, [ ll[0], ll[1] ]); 

         if (i===0) { minx=maxx=ll[1]; miny=maxy=ll[0]; }
         else { minx=(ll[1]<minx)?ll[1]:minx; maxx=(ll[1]>maxx)?ll[1]:maxx; miny=(ll[0]<miny)?ll[0]:miny; maxy=(ll[0]>maxy)?ll[0]:maxy; }
      }
      var cenx = (minx+maxx)/2, ceny = (miny+maxy)/2;
      // console.log('Координати: minx=' + minx + ' miny=' + miny + ' miny=' + miny + ' maxy=' + maxy + ' cenx=' + cenx + ' ceny=' + ceny);

      async function getFDataPage(url = '', formData = {}) {
         const _url = new URL(url);
         var response;
         response = await fetch(_url, { method: 'POST', mode:'cors', credentials:'same-origin', referrer: _url, body: formData }); 
         if (response.ok) { return await response.text();} 
         else {
            return {'error':'Помилка читання інформації зі сторінки'};
      }}

      var formData = new FormData();
      formData.append('x', cenx );
      formData.append('y', ceny );
      formData.append('zoom','16' );
      formData.append('actLayers[]','kadastr');
      return getFDataPage('https://e.land.gov.ua/back/parcel_registration/submission/get_feature_info', formData).then((request) => {
         var json = JSON.parse(request);
         if (json['Інфо про ділянку']) {
            return {'message': json['Інфо про ділянку'][0]['Кадастровий номер'] , 'desc' : 'information_available' };
         } return {'message':'Інформація про ділянку за даними координатами відсутня', 'desc' : 'no_information_available' };
      });
   }

   getUserInfo (au) {
      function getAddress(sender, elm) {
         var ad = sender.get1( elm, 'Address');
         var e, result = '';
         if (ad) {
            if (e = sender.nodeVal( sender.get1( ad, 'Country')))      result = result === ''? e: result + ',' + e; 
            if (e = sender.nodeVal( sender.get1( ad, 'ZIP')))          result = result === ''? e: result + ',' + e; 
            if (e = sender.nodeVal( sender.get1( ad, 'Region')))       result = result === ''? e: result + ',' + e; 
            if (e = sender.nodeVal( sender.get1( ad, 'District')))     result = result === ''? e: result + ',' + e; 
            if (e = sender.nodeVal( sender.get1( ad, 'Settlement')))   result = result === ''? e: result + ',' + e; 
            if (e = sender.nodeVal( sender.get1( ad, 'Street')))       result = result === ''? e: result + ',' + e; 
            if (e = sender.nodeVal( sender.get1( ad, 'Building')))     result = result === ''? e: result + ',' + e; 
            if (e = sender.nodeVal( sender.get1( ad, 'Block')))        result = result === ''? e: result + ',' + e; 
            if (e = sender.nodeVal( sender.get1( ad, 'BuildingUnit'))) result = result === ''? e: result + ',' + e; 
         }  return result;
      }

      var user = {};
      var np = this.get1( au, 'NaturalPerson');
      var le = this.get1( au, 'LegalEntity');

      user.type = np?'NaturalPerson':'LegalEntity';
      user.user_name = '';
      if (np) {
          var fn = this.get1( np, 'FullName');
          if (fn) {
              if (this.get1( fn, 'LastName')) { user.user_lname = this.nodeVal( this.get1( fn, 'LastName')); user.user_name += (user.user_name==''?'':' ')+user.user_lname; }
              if (this.get1( fn, 'FirstName')) { user.user_fname = this.nodeVal( this.get1( fn, 'FirstName')); user.user_name += (user.user_name==''?'':' ')+user.user_fname; }
              if (this.get1( fn, 'MiddleName')) { user.user_mname = this.nodeVal( this.get1( fn, 'MiddleName')); user.user_name += (user.user_name==''?'':' ')+user.user_mname; }
          }
          user.user_inn = this.get1( np, 'TaxNumber')?this.nodeVal( this.get1( np, 'TaxNumber')):'';
          var ps = this.get1( np, 'Passport');
          if (ps) {
             user.user_document_series = this.get1( ps, 'PassportSeries')?this.nodeVal( this.get1( ps, 'PassportSeries')):'';
             user.user_document_number = this.get1( ps, 'PassportNumber')?this.nodeVal( this.get1( ps, 'PassportNumber')):'';
             user.user_document_dateIssue = this.get1( ps, 'PassportIssuedDate')?this.nodeVal( this.get1( ps, 'PassportIssuedDate')).replace( /(\d{4})-(\d{2})-(\d{2})/, "$3-$2-$1"):'';
          }
      }                                            
      if (le) {
          user.user_lname = (this.get1( le, 'Name'))?this.nodeVal( this.get1( le, 'Name')):'';
          user.user_inn = (this.get1( le, 'EDRPOU'))?this.nodeVal( this.get1( le, 'EDRPOU')):''; 
      }
      user.user_address = getAddress(this, np?np:le);

      return user;
   }

   Read(xml, opt) {
      var parser, doc;
      if (parser = new DOMParser()) {
         if (doc = parser.parseFromString(xml, "application/xml")) {
            // main procedure
            var ukr = this.get(doc, 'UkrainianCadastralExchangeFile');
            if (ukr != undefined && ukr.length > 0) 
            {
                try {
                   var cs = this.get(doc, 'CoordinateSystem')[0].childNodes[1];
                   this.coordsys.name = (cs.nodeName === 'Local')?this.nodeVal(cs):cs.nodeName;
                } catch(e) {
                   throw 'Неможливо визначити систему координат поточного файлу!';
                }

                var pt = this.get(doc, 'Point'),
                    pl = this.get(doc, 'PL'),
                    points = [],
                    lands  = [];
            
                for (var t in pt) {
                    if (pt[t].nodeName != undefined && pt[t].nodeName == 'Point') {
                        var id = this.get1( pt[ t], 'UIDP').textContent;
                        var n  = this.get1( pt[ t], 'PN') ? this.get1( pt[ t], 'PN').textContent : '';
                        var x  = parseFloat(this.get1( pt[ t], 'X').textContent);
                        var y  = parseFloat(this.get1( pt[ t], 'Y').textContent);
                        var d  = this.get1( pt[ t], 'Description') ? this.get1( pt[ t], 'Description').textContent : '';
                        points[ id] = {'x':x, 'y':y, 'n':n, 'd':d};
                    }
                }
            
                for (var l in pl) {
                    if (pl[l].nodeName != undefined && pl[l].nodeName == 'PL') {
                        var id  = this.get1( pl[ l], 'ULID').textContent;
                        var pnt = this.get( pl[ l], 'P');
                        lands[ id] = [];
                        
                        for (var p in pnt) {
                            if (pnt[p].nodeName != undefined && pnt[p].nodeName == 'P') {
                                lands[ id].push( pnt[ p].textContent);
                            }
                        }
                    }
                }
                
                var polygons = [];
                    
                if (pl.length > 0)
                {
                    var czi = this.get( doc, 'CadastralZoneInfo');
            
                    for (var z = 0; z < czi.length; z++) 
                    {
                        var cqi = this.get( czi[z], 'CadastralQuarterInfo');
            
                        for (var q = 0; q < cqi.length; q++) 
                        {
                            var pi = this.get( cqi[q], 'ParcelInfo');
                            
                            for (var o = 0; o < pi.length; o++) 
                            {
                                var metrics = this.get( pi[ o], 'ParcelMetricInfo');
                                var poly = [];
                                var prop = {};
                                
                                // Участок
                                try {
                                    for (var p = 0; p < metrics.length; p++) 
                                    {
                                        var externals = this.get( metrics[ p], 'Externals');
            
                                        for (var e = 0; e < externals.length; e++) 
                                        {
                                            var boundary = this.get( externals[ e], 'Boundary');
            
                                            for (var b = 0; b < boundary.length; b++) {
                                                var lines = this.get1( boundary[ b], 'Lines');
                                                var coords = this.xmlCoords( lines, lands, points);
                                                poly.push( coords);
                                            }
            
                                            var internals = this.get( externals[ e], 'Internals');
            
                                            for (var e = 0; e < internals.length; e++) {
                                                var boundary = this.get( internals[ e], 'Boundary');
            
                                                for (var b = 0; b < boundary.length; b++) {
                                                    var lines = this.get1( boundary[ b], 'Lines');
                                                    var coords = this.xmlCoords( lines, lands, points);
                                                    poly.push( coords);
                                                }
                                            }
                                        }
                                    }
            
                                    var pmi = this.get1( pi[ o], 'ParcelMetricInfo');
            
                                    if (pmi) {
                                        var ikn = this.nodeVal( this.get1( czi[z], 'KOATUU'));
                                        ikn += ":" +this.nodeVal( this.get1( czi[z], 'CadastralZoneNumber'));
                                        ikn += ":" +this.nodeVal( this.get1( cqi[q], 'CadastralQuarterNumber'));
                                        ikn += ":" +this.nodeVal( this.get1( pmi, 'ParcelID'));
                                        
                                        if (!opt.isEditor)
                                            prop[ "Кадастр.номер"] = ikn;
                                        else
                                            prop[ "IKN"] = ikn;
            
                                        var cpi = this.get1( pi[ o], 'CategoryPurposeInfo');
            
                                        if (cpi) {
                                            var use = this.nodeVal( this.get1( cpi, 'Purpose'));
                                            use += " " +this.nodeVal( this.get1( cpi, 'Use'));
                                            
                                            if (!opt.isEditor)
                                                prop[ "Цільове призначення"] = use;
                                            else
                                                prop[ "CV"] = use;
                                        }
            
                                        var area = this.get1( pmi, 'Area');
            
                                        if (area) {
                                            var s = this.nodeVal( this.get1( area, 'Size'));
                                            s += " " +this.nodeVal( this.get1( area, 'MeasurementUnit'));
                                            
                                            if (!opt.isEditor)
                                                prop[ "Площа"] = s;
                                            else
                                                prop[ "AS"] = s;
                                        }
            
                                        var pri = this.get( pi[ o], 'ProprietorInfo');
            
                                        for (var r = 0; r < pri.length; r++) 
                                        {                                    
                                            var au = this.get1( pri[r], 'Authentication');
                                            if (au) {
                                               var user = prop["UserInfo"] = this.getUserInfo(au);
                                               if ('user_name' in user) {
                                                  if (!opt.isEditor)
                                                     prop[ "Власник"] = user.user_name;
                                                  else
                                                     prop[ "NM"] = user.user_name;
                                               }
                                            }
                                        }

                                        var phone = this.get1(doc, 'InfoLandWork');
                                        if (phone) phone = this.get1(phone, 'Executor');
                                        if (phone) phone = this.get1(phone, 'Executor');
                                        if (phone) phone = this.get1(phone, 'ContactInfo');
                                        if (phone) phone = this.nodeVal(this.get1(phone, 'Phone'));
                                        if (phone) {
                                            phone = phone.replace( /[^\d]/g,'');
                                            phone = (phone.length < 12) ? phone = '380322450000'.substring(0, 12 - phone.length) + phone:phone;
                                            phone = phone.replace( /(\d{2})(\d{3})(\d{3})(\d{2})(\d{2})/, "$2$3$4$5");
                                            prop[ "user_tel"] = phone;
                                        }

                                        var dtype = this.get1( pi[ o], 'TechnicalDocumentationInfo');
                                        if (dtype) {
                                            t = this.nodeVal(this.get1( dtype, 'DocumentationType'));
                                            prop[ "doctype"] = t;
                                        }

                                        if (!opt.isEditor) {
                                            var users = this.get1( pi[ o], 'Proprietors');
            
                                            if (users) {
                                                prop[ "XML"] = this.getXmlStr( users);
                                            }
                                        } else {
                                            prop[ "name"] = opt.filename;
                                            
                                            var osi = this.get1( pi[ o], 'OwnershipInfo');
            
                                            if (osi) {
                                                var code = this.nodeVal( this.get1( osi, 'Code'));
                                                prop[ "PF"] = code;
                                            }
                                            
                                            var pli = this.get1( pi[ o], 'ParcelLocationInfo');
            
                                            if (pli) {
                                                var adr = "";
                                                adr = this.addVal( adr, pli, 'Settlement');
                                                
                                                var pa = this.get1( pli, 'ParcelAddress');
                                                
                                                if (pa) {
                                                    adr = this.addVal( adr, pa, 'StreetType');
                                                    adr = this.addVal( adr, pa, 'StreetName');
                                                    adr = this.addVal( adr, pa, 'Building');
                                                    adr = this.addVal( adr, pa, 'Block');
                                                }
            
                                                adr = this.addVal( adr, pli, 'District');
                                                adr = this.addVal( adr, pli, 'Region');
            
                                                prop[ "AD"] = adr.trim();
                                            }
                                            
                                            var pri = this.get1( pi[ o], 'ProprietorInfo');
                                            
                                            if (pri) {
                                                var dec = "";
                                                var aib = this.get1( pri, 'AdditionalInfoBlock');
                                                
                                                if (aib) {
                                                    //AdditionalInfo
                                                }
                                                
                                                var paj = this.get1( pri, 'PropertyAcquisitionJustification');
                                                
                                                if (paj) {
                                                    //Document
                                                    dec = this.addVal( dec, paj, 'DocumentDate');
                                                    dec = this.addVal( dec, paj, 'DocumentNumber');
                                                    dec = this.addVal( dec, paj, 'ApprovalAuthority');
                                                }
                                                
                                                prop[ "PZ"] = dec.trim();
                                            }
                                        }
                                    }
            
                                    var polygon = { type: 'Parcels',
                                                    properties: prop,
                                                    styles: {color:'Black',weight:3,fillOpacity:0.3},
                                                    geometry: {
                                                        type: 'Polygon',
                                                        coordinates: poly
                                                    }
                                                  };
            
                                    polygons.push( polygon);
                                } catch (err) {
                                    console.log( err);
                                }
            
                                // Угодья
                                if (!opt.isEditor)
                                try {
                                    var lpi = this.get( pi[ o], 'LandParcelInfo');
            
                                    for (var r = 0; r < lpi.length; r++) 
                                    {                                    
                                        var lmi = this.get1( lpi[ r], 'MetricInfo');
            
                                        if (lmi) 
                                        {
                                            poly = [];
                                            prop = {};
            
                                            var landcode = this.get1( lpi[ r], 'LandCode');
            
                                            if (landcode) {
                                                prop[ "Код угіддя"] = this.nodeVal( landcode);
                                            }
            
                                            var area = this.get1( lmi, 'Area');
            
                                            if (area) {
                                                var s = this.nodeVal( this.get1( area, 'Size'));
                                                s += " " +this.nodeVal( this.get1( area, 'MeasurementUnit'));
                                                prop[ "Площа"] = s;
                                            }
            
                                            var len = this.get1( lmi, 'Perimeter');
            
                                            if (len) {
                                                prop[ "Периметр"] = this.nodeVal( len) +" м";
                                            }
            
                                            var externals = this.get( lpi[ r], 'Externals');
            
                                            for (var e = 0; e < externals.length; e++) {
                                                var boundary = this.get( externals[ e], 'Boundary');
            
                                                for (var b = 0; b < boundary.length; b++) {
                                                    var lines = this.get1( boundary[ b], 'Lines');
                                                    var coords = this.xmlCoords( lines, lands, points);
                                                    poly.push( coords);
                                                }
            
                                                var internals = this.get( externals[ e], 'Internals');
            
                                                for (var e = 0; e < internals.length; e++) {
                                                    var boundary = this.get( internals[ e], 'Boundary');
            
                                                    for (var b = 0; b < boundary.length; b++) {
                                                        var lines = this.get1( boundary[ b], 'Lines');
                                                        var coords = this.xmlCoords( lines, lands, points);
                                                        poly.push( coords);
                                                    }
                                                }
                                            }
            
                                            var polygon = { type: 'LandParcel',
                                                            properties: prop,
                                                            styles: {color:'Blue',weight:2,fillOpacity:0.3,fill:"false"},
                                                            geometry: {
                                                                type: 'Polygon',
                                                                coordinates: poly
                                                            }
                                                          };
            
                                            polygons.push( polygon);
                                        }
                                    }
                                } catch (err) {
                                    console.log( err);
                                }
                                
                                // Смежества
                                if (!opt.isEditor)
                                try {
                                    var au = this.get( pi[ o], 'AdjacentUnits');
            
                                    for (var u = 0; u < au.length; u++) 
                                    {                                    
                                        var aui = this.get( au[ u], 'AdjacentUnitInfo');
                                        
                                        for (var ui = 0; ui < aui.length; ui++) 
                                        {         
                                            var unit = aui[ ui]
                                                
                                            poly = [];
                                            prop = {};
                                            
                                            var boundary = this.get( unit, 'AdjacentBoundary');
            
                                            for (var b = 0; b < boundary.length; b++) {
                                                var lines = this.get1( boundary[ b], 'Lines');
                                                var coords = this.xmlCoords( lines, lands, points);
                                                poly.push( coords);
                                            }
                                            
                                            var cadn = this.get1( unit, 'CadastralNumber');
            
                                            if (cadn) {
                                                var s = this.nodeVal( cadn);
                                                prop[ "CadastralNumber"] = s;
                                            }          
                                            
                                            var users = this.get1( unit, 'Proprietor');
                                            
                                            if (users) {
                                                prop[ "XML"] = this.getXmlStr(users);
                                            }
                                            
                                            var polygon = { type: 'AdjacentUnits',
                                                            properties: prop,
                                                            styles: {color:'Black',weight:1,fillOpacity:0.3},
                                                            geometry: {
                                                                type: 'LineString',
                                                                coordinates: poly[0]
                                                            }
                                                          };
            
                                            polygons.push( polygon);
                                        }
                                    }
            
                                } catch (err) {
                                    console.log( err);
                                }
                            }
                        }
                    }
                }
                this.Polygons = polygons;
                return polygons;
            }
                
        }
      }
   }
}

